OGRE: Ogre::Font Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::Font Class Reference

Class representing a font in the system. More...

`#include <OgreFont.h>`

Inheritance diagram for Ogre::Font:

[legend]
List of all members.

## Public Types

typedef Ogre::uint32 | CodePoint
typedef Ogre::FloatRect | UVRect
typedef std::pair< CodePoint, CodePoint > | CodePointRange
| A range of code points, inclusive on both ends.
typedef std::vector< CodePointRange > | CodePointRangeList
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING }
| Enum identifying the loading state of the resource. More...

## Public Member Functions

| Font (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor.
virtual | ~Font ()
void | setType (FontType ftype)
| Sets the type of font.
FontType | getType (void) const
| Gets the type of font.
void | setSource (const String &source)
| Sets the source of the font.
const String & | getSource (void) const
| Gets the source this font (either an image or a truetype font).
void | setTrueTypeSize (Real ttfSize)
| Sets the size of a truetype font (only required for FT_TRUETYPE).
void | setTrueTypeResolution (uint ttfResolution)
| Gets the resolution (dpi) of the font used to generate the texture (only required for FT_TRUETYPE).
Real | getTrueTypeSize (void) const
| Gets the point size of the font used to generate the texture.
uint | getTrueTypeResolution (void) const
| Gets the resolution (dpi) of the font used to generate the texture.
const UVRect & | getGlyphTexCoords (CodePoint id) const
| Returns the teture coordinates of the associated glyph.
void | setGlyphTexCoords (CodePoint id, Real u1, Real v1, Real u2, Real v2, Real textureAspect)
| Sets the texture coordinates of a glyph.
Real | getGlyphAspectRatio (CodePoint id) const
| Gets the aspect ratio (width / height) of this character.
void | setGlyphAspectRatio (CodePoint id, Real ratio)
| Sets the aspect ratio (width / height) of this character.
const GlyphInfo & | getGlyphInfo (CodePoint id) const
| Gets the information available for a glyph corresponding to a given code point, or throws an exception if it doesn't exist;.
void | addCodePointRange (const CodePointRange &range)
| Adds a range of code points to the list of code point ranges to generate glyphs for, if this is a truetype based font.
void | clearCodePointRanges ()
| Clear the list of code point ranges.
const CodePointRangeList & | getCodePointRangeList () const
| Get a const reference to the list of code point ranges to be used to generate glyphs from a truetype font.
const MaterialPtr & | getMaterial () const
| Gets the material generated for this font, as a weak reference.
const MaterialPtr & | getMaterial ()
| Gets the material generated for this font, as a weak reference.
void | setAntialiasColour (bool enabled)
| Sets whether or not the colour of this font is antialiased as it is generated from a true type font.
bool | getAntialiasColour (void) const
| Gets whether or not the colour of this font is antialiased as it is generated from a true type font.
void | loadResource (Resource *resource)
| Implementation of ManualResourceLoader::loadResource, called when the Texture that this font creates needs to (re)load.
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already.
virtual void | reload (void)
| Reloads the resource, if it is already loaded.
bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise.
bool | isManuallyLoaded (void) const
| Is this resource manually loaded?
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required.
size_t | getSize (void) const
| Retrieves info about the size of the resource.
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used.
const String & | getName (void) const
| Gets resource name.
ResourceHandle | getHandle (void) const
bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise.
LoadingState | isLoading () const
| Returns whether the resource is currently in the process of background loading.
LoadingState | getLoadingState () const
| Returns the current loading state.
bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading.
void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not.
void | escalateLoading ()
| Escalates the loading of a background loaded resource.
void | addListener (Listener *lis)
| Register a listener on this resource.
void | removeListener (Listener *lis)
| Remove a listener on this resource.
const String & | getGroup (void)
| Gets the group which this resource is a member of.
void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource.
ResourceManager * | getCreator (void)
| Gets the manager which created this resource.
const String & | getOrigin (void) const
| Get the origin of this resource, e.g.
void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin.
virtual void | _fireBackgroundLoadingComplete (void)
| Firing of background loading complete event.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.

## Static Public Member Functions

static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

## Protected Types

typedef std::map< CodePoint, GlyphInfo > | CodePointMap
| Map from unicode code point to texture coordinates.
typedef std::list< Listener * > | ListenerList

## Protected Member Functions

void | createTextureFromFont (void)
| Internal method for loading from ttf.
virtual void | loadImpl ()
virtual void | unloadImpl ()
size_t | calculateSize (void) const
virtual void | preLoadImpl (void)
| Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.
virtual void | postLoadImpl (void)
| Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.
virtual void | preUnloadImpl (void)
| Internal hook to perform actions before the unload process.
virtual void | postUnloadImpl (void)
| Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.
virtual void | queueFireBackgroundLoadingComplete (void)
| Queue the firing of background loading complete event.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.

## Protected Attributes

FontType | mType
| The type of font.
String | mSource
| Source of the font (either an image name or a truetype font).
Real | mTtfSize
| Size of the truetype font, in points.
uint | mTtfResolution
| Resolution (dpi) of truetype font.
CodePointMap | mCodePointMap
MaterialPtr | mpMaterial
| The material which is generated for this font.
TexturePtr | mTexture
| Texture pointer.
bool | mAntialiasColour
| for TRUE_TYPE font only
CodePointRangeList | mCodePointRangeList
| Range of code points to generate glyphs for (truetype only).
ResourceManager * | mCreator
| Creator.
String | mName
| Unique name of the resource.
String | mGroup
| The name of the resource group.
ResourceHandle | mHandle
| Numeric handle for more efficient look up than name.
volatile LoadingState | mLoadingState
| Is the resource currently loaded?
volatile bool | mIsBackgroundLoaded
| Is this resource going to be background loaded? Only applicable for multithreaded.
size_t | mSize
| Mutex to cover the status of loading The size of the resource in bytes.
bool | mIsManual
| Is this file manually loaded?
String | mOrigin
| Origin of this resource (e.g. script name) - optional.
ManualResourceLoader * | mLoader
| Optional manual loader; if provided, data is loaded from here instead of a file.
ListenerList | mListenerList
String | mParamDictName
| Class name for this instance to be used as a lookup (must be initialised by subclasses).

## Static Protected Attributes

static CmdType | msTypeCmd
static CmdSource | msSourceCmd
static CmdSize | msSizeCmd
static CmdResolution | msResolutionCmd
static CmdCodePoints | msCodePointsCmd
static ParamDictionaryMap | msDictionary
| Dictionary of parameters.

## Classes

class | CmdCodePoints
| Command object for Font - see ParamCommand. More...
class | CmdResolution
| Command object for Font - see ParamCommand. More...
class | CmdSize
| Command object for Font - see ParamCommand. More...
class | CmdSource
| Command object for Font - see ParamCommand. More...
class | CmdType
| Command object for Font - see ParamCommand. More...
struct | GlyphInfo
| Information about the position and size of a glyph in a texture. More...

## Detailed Description

Class representing a font in the system.

Remarks:
  This class is simply a way of getting a font texture into the OGRE system and to easily retrieve the texture coordinates required to accurately render them. Fonts can either be loaded from precreated textures, or the texture can be generated using a truetype font. You can either create the texture manually in code, or you can use a .fontdef script to define it (probably more practical since you can reuse the definition more easily)

Note:
  This class extends both Resource and ManualResourceLoader since it is both a resource in it's own right, but it also provides the manual load implementation for the Texture it creates.

Definition at line 60 of file OgreFont.h.

## Member Typedef Documentation

typedef Ogre::uint32 Ogre::Font::CodePoint

| Definition at line 119 of file OgreFont.h.

typedef std::map<CodePoint, GlyphInfo> Ogre::Font::CodePointMap`[protected]`

| Map from unicode code point to texture coordinates. Definition at line 139 of file OgreFont.h.

typedef std::pair<CodePoint, CodePoint> Ogre::Font::CodePointRange

| A range of code points, inclusive on both ends. Definition at line 135 of file OgreFont.h.

typedef std::vector<CodePointRange> Ogre::Font::CodePointRangeList

| Definition at line 136 of file OgreFont.h.

typedef std::list<Listener*> Ogre::Resource::ListenerList`[protected, inherited]`

| Definition at line 131 of file OgreResource.h.

typedef Ogre::FloatRect Ogre::Font::UVRect

| Definition at line 120 of file OgreFont.h.

## Member Enumeration Documentation

enum Ogre::Resource::LoadingState`[inherited]`

Enum identifying the loading state of the resource.

Enumeration values:

  LOADSTATE_UNLOADED | Not loaded.
  LOADSTATE_LOADING | Loading is in progress.
  LOADSTATE_LOADED | Fully loaded.
  LOADSTATE_UNLOADING | Currently unloading.

Definition at line 96 of file OgreResource.h.

## Constructor & Destructor Documentation

Ogre::Font::Font | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`
| ) |

Constructor.

See also:
  Resource

virtual Ogre::Font::~Font | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual void Ogre::Resource::_fireBackgroundLoadingComplete | ( | void |  | ) | `[virtual, inherited]`

Firing of background loading complete event.

Remarks:
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) | `[inherited]`

| Notify this resource of it's origin. Definition at line 358 of file OgreResource.h.

void Ogre::Font::addCodePointRange | ( | const CodePointRange & | range | ) |

Adds a range of code points to the list of code point ranges to generate glyphs for, if this is a truetype based font.

Remarks:
  In order to save texture space, only the glyphs which are actually needed by the application are generated into the texture. Before this object is loaded you must call this method as many times as necessary to define the code point range that you need.

Definition at line 312 of file OgreFont.h.

void Ogre::Resource::addListener | ( | Listener * | lis | ) | `[inherited]`

Register a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

size_t Ogre::Font::calculateSize | ( | void |  | ) | const`[protected, virtual]`

| Implements Ogre::Resource. Definition at line 162 of file OgreFont.h.

void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) | `[inherited]`

Change the resource group ownership of a Resource.

Remarks:
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters:

  | newGroup | Name of the new group

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. MaterialManager) initializes.

void Ogre::Font::clearCodePointRanges | ( |  | ) |

| Clear the list of code point ranges. Definition at line 319 of file OgreFont.h.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 300 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 176 of file OgreStringInterface.h.

void Ogre::Font::createTextureFromFont | ( | void |  | ) | `[protected]`

| Internal method for loading from ttf.

void Ogre::Resource::escalateLoading | ( |  | ) | `[inherited]`

Escalates the loading of a background loaded resource.

Remarks:
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

bool Ogre::Font::getAntialiasColour | ( | void |  | ) | const

| Gets whether or not the colour of this font is antialiased as it is generated from a true type font. Definition at line 365 of file OgreFont.h.

const CodePointRangeList& Ogre::Font::getCodePointRangeList | ( |  | ) | const

| Get a const reference to the list of code point ranges to be used to generate glyphs from a truetype font. Definition at line 326 of file OgreFont.h.

ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) | `[inherited]`

| Gets the manager which created this resource. Definition at line 349 of file OgreResource.h.

Real Ogre::Font::getGlyphAspectRatio | ( | CodePoint | id | ) | const

| Gets the aspect ratio (width / height) of this character. Definition at line 273 of file OgreFont.h.

const GlyphInfo& Ogre::Font::getGlyphInfo | ( | CodePoint | id | ) | const

| Gets the information available for a glyph corresponding to a given code point, or throws an exception if it doesn't exist;.

const UVRect& Ogre::Font::getGlyphTexCoords | ( | CodePoint | id | ) | const

Returns the teture coordinates of the associated glyph.

Remarks:
  Parameter is a short to allow both ASCII and wide chars.

Parameters:

  | id | The code point (unicode)

Returns:
  A rectangle with the UV coordinates, or null UVs if the code point was not present

Definition at line 231 of file OgreFont.h.

const String& Ogre::Resource::getGroup | ( | void |  | ) | `[inherited]`

| Gets the group which this resource is a member of. Reimplemented in Ogre::SkeletonInstance. Definition at line 337 of file OgreResource.h.

ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const`[inherited]`

| Reimplemented in Ogre::SkeletonInstance. Definition at line 263 of file OgreResource.h.

LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const`[inherited]`

| Returns the current loading state. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 286 of file OgreResource.h.

const MaterialPtr& Ogre::Font::getMaterial | ( |  | ) |

Gets the material generated for this font, as a weak reference.

Remarks:
  This will only be valid after the Font has been loaded.

Definition at line 342 of file OgreFont.h.

const MaterialPtr& Ogre::Font::getMaterial | ( |  | ) | const

Gets the material generated for this font, as a weak reference.

Remarks:
  This will only be valid after the Font has been loaded.

Definition at line 334 of file OgreFont.h.

const String& Ogre::Resource::getName | ( | void |  | ) | const`[inherited]`

| Gets resource name. Reimplemented in Ogre::SkeletonInstance. Definition at line 258 of file OgreResource.h.

const String& Ogre::Resource::getOrigin | ( | void |  | ) | const`[inherited]`

Get the origin of this resource, e.g.

a script file name.

Remarks:
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

Definition at line 356 of file OgreResource.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

| Definition at line 213 of file OgreStringInterface.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 200 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 269 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

size_t Ogre::Resource::getSize | ( | void |  | ) | const`[inherited]`

| Retrieves info about the size of the resource. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 247 of file OgreResource.h.

const String& Ogre::Font::getSource | ( | void |  | ) | const

| Gets the source this font (either an image or a truetype font).

uint Ogre::Font::getTrueTypeResolution | ( | void |  | ) | const

Gets the resolution (dpi) of the font used to generate the texture.

Remarks:
  Only applicable for FT_TRUETYPE Font objects.

Real Ogre::Font::getTrueTypeSize | ( | void |  | ) | const

Gets the point size of the font used to generate the texture.

Remarks:
  Only applicable for FT_TRUETYPE Font objects. Note that the size of the font does not affect how big it is on the screen, just how large it is in the texture and thus how detailed it is.

FontType Ogre::Font::getType | ( | void |  | ) | const

| Gets the type of font.

bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const`[inherited]`

Returns whether this Resource has been earmarked for background loading.

Remarks:
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 303 of file OgreResource.h.

bool Ogre::Resource::isLoaded | ( | void |  | ) | const`[inherited]`

| Returns true if the Resource has been loaded, false otherwise. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 270 of file OgreResource.h.

LoadingState Ogre::Resource::isLoading | ( |  | ) | const`[inherited]`

| Returns whether the resource is currently in the process of background loading. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 279 of file OgreResource.h.

bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const`[inherited]`

| Is this resource manually loaded? Definition at line 235 of file OgreResource.h.

bool Ogre::Resource::isReloadable | ( | void |  | ) | const`[inherited]`

| Returns true if the Resource is reloadable, false otherwise. Reimplemented in Ogre::UnifiedHighLevelGpuProgram. Definition at line 228 of file OgreResource.h.

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) | `[virtual, inherited]`

Loads the resource, if it is not already.

Remarks:
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters:

  | backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Font::loadImpl | ( |  | ) | `[protected, virtual]`

| Implements Ogre::Resource.

void Ogre::Font::loadResource | ( | Resource * | resource | ) | `[virtual]`

| Implementation of ManualResourceLoader::loadResource, called when the Texture that this font creates needs to (re)load. Implements Ogre::ManualResourceLoader.

virtual void Ogre::Resource::postLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the load process, but before the resource has been marked as fully loaded.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Reimplemented in Ogre::Mesh.

Definition at line 156 of file OgreResource.h.

virtual void Ogre::Resource::postUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions after the unload process, but before the resource has been marked as fully unloaded.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 166 of file OgreResource.h.

virtual void Ogre::Resource::preLoadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the load process, but after the resource has been marked as 'loading'.

Note:
  Mutex will have already been acquired by the loading thread. Also, this call will occur even when using a ManualResourceLoader (when loadImpl is not actually called)

Definition at line 149 of file OgreResource.h.

virtual void Ogre::Resource::preUnloadImpl | ( | void |  | ) | `[protected, virtual, inherited]`

Internal hook to perform actions before the unload process.

Note:
  Mutex will have already been acquired by the unloading thread.

Definition at line 161 of file OgreResource.h.

virtual void Ogre::Resource::queueFireBackgroundLoadingComplete | ( | void |  | ) | `[protected, virtual, inherited]`

| Queue the firing of background loading complete event.

virtual void Ogre::Resource::reload | ( | void |  | ) | `[virtual, inherited]`

Reloads the resource, if it is already loaded.

Remarks:
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Resource::removeListener | ( | Listener * | lis | ) | `[inherited]`

Remove a listener on this resource.

See also:
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

void Ogre::Font::setAntialiasColour | ( | bool | enabled | ) |

Sets whether or not the colour of this font is antialiased as it is generated from a true type font.

Remarks:
  This is valid only for a FT_TRUETYPE font. If you are planning on using alpha blending to draw your font, then it is a good idea to set this to false (which is the default), otherwise the darkening of the font will combine with the fading out of the alpha around the edges and make your font look thinner than it should. However, if you intend to blend your font using a colour blending mode (add or modulate for example) then it's a good idea to set this to true, in order to soften your font edges.

Definition at line 357 of file OgreFont.h.

void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) | `[inherited]`

Tells the resource whether it is background loaded or not.

Remarks:

See also:
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

Definition at line 313 of file OgreResource.h.

void Ogre::Font::setGlyphAspectRatio | ( | CodePoint | id,
|  | Real | ratio
| ) |

Sets the aspect ratio (width / height) of this character.

Remarks:
  You only need to call this if you're setting up a font loaded from a texture manually.

Definition at line 290 of file OgreFont.h.

void Ogre::Font::setGlyphTexCoords | ( | CodePoint | id,
|  | Real | u1,
|  | Real | v1,
|  | Real | u2,
|  | Real | v2,
|  | Real | textureAspect
| ) |

Sets the texture coordinates of a glyph.

Remarks:
  You only need to call this if you're setting up a font loaded from a texture manually.

Note:
  Also sets the aspect ratio (width / height) of this character. textureAspect is the width/height of the texture (may be non-square)

Definition at line 252 of file OgreFont.h.

References Ogre::TRect< T >::bottom, Ogre::TRect< T >::left, Ogre::TRect< T >::right, and Ogre::TRect< T >::top.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

void Ogre::Font::setSource | ( | const String & | source | ) |

Sets the source of the font.

Remarks:
  If you have created a font of type FT_IMAGE, this method tells the Font which image to use as the source for the characters. So the parameter should be the name of an appropriate image file. Note that when using an image as a font source, you will also need to tell the font where each character is located using setGlyphTexCoords (for each character).

  If you have created a font of type FT_TRUETYPE, this method tells the Font which .ttf file to use to generate the text. You will also need to call setTrueTypeSize and setTrueTypeResolution, and call addCodePointRange as many times as required to define the range of glyphs you want to be available.

Parameters:

  | source | An image file or a truetype font, depending on the type of this font

void Ogre::Font::setTrueTypeResolution | ( | uint | ttfResolution | ) |

Gets the resolution (dpi) of the font used to generate the texture (only required for FT_TRUETYPE).

Parameters:

  | ttfResolution | The resolution in dpi

void Ogre::Font::setTrueTypeSize | ( | Real | ttfSize | ) |

Sets the size of a truetype font (only required for FT_TRUETYPE).

Parameters:

  | ttfSize | The size of the font in points. Note that the size of the font does not affect how big it is on the screen, just how large it is in the texture and thus how detailed it is.

void Ogre::Font::setType | ( | FontType | ftype | ) |

| Sets the type of font. Must be set before loading.

virtual void Ogre::Resource::touch | ( | void |  | ) | `[virtual, inherited]`

| 'Touches' the resource to indicate it has been used. Reimplemented in Ogre::Material, and Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Resource::unload | ( | void |  | ) | `[virtual, inherited]`

| Unloads the resource; this is not permanent, the resource can be reloaded later if required. Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

virtual void Ogre::Font::unloadImpl | ( |  | ) | `[protected, virtual]`

| Implements Ogre::Resource.

## Member Data Documentation

bool Ogre::Font::mAntialiasColour`[protected]`

| for TRUE_TYPE font only Definition at line 149 of file OgreFont.h.

CodePointMap Ogre::Font::mCodePointMap`[protected]`

| Definition at line 140 of file OgreFont.h.

CodePointRangeList Ogre::Font::mCodePointRangeList`[protected]`

| Range of code points to generate glyphs for (truetype only). Definition at line 152 of file OgreFont.h.

ResourceManager* Ogre::Resource::mCreator`[protected, inherited]`

| Creator. Definition at line 109 of file OgreResource.h.

String Ogre::Resource::mGroup`[protected, inherited]`

| The name of the resource group. Definition at line 113 of file OgreResource.h.

ResourceHandle Ogre::Resource::mHandle`[protected, inherited]`

| Numeric handle for more efficient look up than name. Definition at line 115 of file OgreResource.h.

volatile bool Ogre::Resource::mIsBackgroundLoaded`[protected, inherited]`

| Is this resource going to be background loaded? Only applicable for multithreaded. Definition at line 119 of file OgreResource.h.

bool Ogre::Resource::mIsManual`[protected, inherited]`

| Is this file manually loaded? Definition at line 125 of file OgreResource.h.

ListenerList Ogre::Resource::mListenerList`[protected, inherited]`

| Definition at line 132 of file OgreResource.h.

ManualResourceLoader* Ogre::Resource::mLoader`[protected, inherited]`

| Optional manual loader; if provided, data is loaded from here instead of a file. Definition at line 129 of file OgreResource.h.

volatile LoadingState Ogre::Resource::mLoadingState`[protected, inherited]`

| Is the resource currently loaded? Definition at line 117 of file OgreResource.h.

String Ogre::Resource::mName`[protected, inherited]`

| Unique name of the resource. Definition at line 111 of file OgreResource.h.

String Ogre::Resource::mOrigin`[protected, inherited]`

| Origin of this resource (e.g. script name) - optional. Definition at line 127 of file OgreResource.h.

String Ogre::StringInterface::mParamDictName`[protected, inherited]`

| Class name for this instance to be used as a lookup (must be initialised by subclasses). Definition at line 164 of file OgreStringInterface.h.

MaterialPtr Ogre::Font::mpMaterial`[protected]`

| The material which is generated for this font. Definition at line 143 of file OgreFont.h.

CmdCodePoints Ogre::Font::msCodePointsCmd`[static, protected]`

| Definition at line 104 of file OgreFont.h.

ParamDictionaryMap Ogre::StringInterface::msDictionary`[static, protected, inherited]`

| Dictionary of parameters. Definition at line 161 of file OgreStringInterface.h.

size_t Ogre::Resource::mSize`[protected, inherited]`

| Mutex to cover the status of loading The size of the resource in bytes. Definition at line 123 of file OgreResource.h.

String Ogre::Font::mSource`[protected]`

| Source of the font (either an image name or a truetype font). Definition at line 110 of file OgreFont.h.

CmdResolution Ogre::Font::msResolutionCmd`[static, protected]`

| Definition at line 103 of file OgreFont.h.

CmdSize Ogre::Font::msSizeCmd`[static, protected]`

| Definition at line 102 of file OgreFont.h.

CmdSource Ogre::Font::msSourceCmd`[static, protected]`

| Definition at line 101 of file OgreFont.h.

CmdType Ogre::Font::msTypeCmd`[static, protected]`

| Definition at line 100 of file OgreFont.h.

TexturePtr Ogre::Font::mTexture`[protected]`

| Texture pointer. Definition at line 146 of file OgreFont.h.

uint Ogre::Font::mTtfResolution`[protected]`

| Resolution (dpi) of truetype font. Definition at line 115 of file OgreFont.h.

Real Ogre::Font::mTtfSize`[protected]`

| Size of the truetype font, in points. Definition at line 113 of file OgreFont.h.

FontType Ogre::Font::mType`[protected]`

| The type of font. Definition at line 107 of file OgreFont.h.

The documentation for this class was generated from the following file:

- OgreFont.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:46:45 2008